//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#ifndef saori_h
#define saori_h
//-----
#include <iterator>
#include <iostream.h>
#include <string>               // for string class
#include <vector>

int saori_load(string datapath);
int saori_unload(void);
int saori_execute(string *request_buffer);

#define SAORI_SECURITYLV	"SecurityLevel"
#define SAORI_CHARSET		"Charset"
#define SAORI_SENDER		"Sender"
#define SAORI_ARGUMENT		"Argument"

#define COM_GET_VERSION		1
#define COM_EXECUTE			2

class Saori_data{
	unsigned int command_code;
	unsigned int command_version;
	string command;
	string securitylevel;
	string charset;
	string sender;
	vector<string> argument;					// ̓f[^
	
	unsigned int returncode;
	string result;
	vector<string>  value;
	
	int line_decode(string buffer);
	int header_decode(string *buffer);
	int header_encode(string *answer);
	int set_argument(string buffer,unsigned int num);
	
public:
	int ger_command_code(void);
	string get_argument(unsigned int num);
	string get_value(unsigned int num);
	int set_returncode(unsigned int code);
	int set_result(string buffer);
	int set_value(string buffer,unsigned int num);
	
	int decode(string buffer);			// requestf[^̃fR[hs
	int encode(string *answer);			// requestf[^̃GR	
	int view(void);

};

#endif
